<!-- goodsList 商品列表 -->
<template>
  <div ref="main_box">
    <!-- <div class="flex flex-m tc topbar">
      <div @click="clickTap('0')" :class="{active:search.sort==0}" class="flex-1">综合</div>
      <div @click="clickTap('4')" :class="{active:search.sort==4}" class="flex-1">销量</div>
      <div @click="clickTap('2')" :class="{active:['1','2'].includes(search.sort) }" class="flex-1">价格
        <van-icon :name="search.sort|arrow" />
      </div>
      <div @click="clickTap(-1)" class="flex-1">筛选</div>
    </div> -->
    <div class="goodsList">
      <van-list :immediate-check="false" finished-text="" v-model="list_loading" :finished="list_finished" @load="m_loadList">
        <div @click="clickGoods(item)" class="goodsBox flex" v-for="(item ) in m_data">
          <van-image class="goodsList-img" width="2.8rem" height="2.8rem" lazy-load :src="item.images[0] | img" />
          <div class="flex-1 goodsBox_con">
            <div class="f1 e2">{{item.title}}</div>
            <div class="flex flex-b flex-m c-m-box">
              <div class="redf">{{symbolpre}}{{item.price}}{{symbolpost}}</div>
              <div>销量{{item.sale_num}}</div>
            </div>
        
          </div>

        </div>
      </van-list>

    </div>

    <nodata v-if="!m_hasData&&!list_loading" />

    <!-- 筛选 -->

    <!-- <van-popup class="searchBox" v-model="show" position="right">
      <div class="searchBox_c">
        <div class="s_item">
          <div class="mb10">价格区间:</div>
          <div class="flex flex-m">
            <input v-fixedInput type="number" class="n_input" v-model="pirce_min" placeholder="最低价" />
            <span class="ml5 mr5">-</span>
            <input v-fixedInput type="number" class="n_input" v-model="price_max" placeholder="最高价" />
          </div>
        </div>

        <div class="searchBox_f flex flex-m">
          <div @click="handelResetbtn" class="resetBtn flex-1 ">重置</div>
          <div @click="handelSureBtn" class="sureBtn flex-1 ">确认</div>
        </div>

      </div>
    </van-popup> -->

  </div>
</template>

<script>
export default {
  name: 'goodsList',
  data() {
    return {
      query: {},
      _search: {},
      search: {
        cid: '', //分类ID,必须是分类列表内的ID
        search: '', //搜索关键字
        is_recommend: '', //推荐商品搜索  0:否  1:推荐商品   全部则传空字符串
        is_new: '', //是否新品 0:否  1:是  全部则传空字符串
        ship_free: '', //是否包邮 0:否  1:是  全部则传空字符串
      },
      symbolpre: '¥',
      symbolpost: '',
      show: false,


    }
  },
  mounted() {
    //  this.init()
  },

  beforeRouteEnter(to, from, next) {

    if (from.path == '/goodsDetail') {
      to.meta.keepAlive = 1;
     
    } else {
      to.meta.keepAlive = 0;
    }
    next()
  },

  activated() {
    let keepAlive = this.$route.meta.keepAlive
    if (keepAlive != 1) {
      this.init()
    } else {
      let query = this.query
      this.sePageTitle(query.name || query.search)
    }
  },
  methods: {
    //初始化方法
    init() {
      this.m_resetData()
      this.query = this.$route.query
      let query = this.query
      this.search = this.m_utils.coverObj(this.search, query)
      if(this.query.name == '牡丹专区券'){
        this.symbolpre  = '';
        this.symbolpost  = '张';
      }
      this._search = this._dep(this.search)
      this.sePageTitle(query.name || query.search)
      this.m_loadList()

    },



    getDataList() {
      let data = { ...this.m_pageInfo, ...this.search }
      return this.api.goods_search(data).then(res => {
        this.m_data = [...this.m_data, ...res.data.data]
        return res
      })

    },

    clickTap(v) {
      if (v == -1) {
        //筛选
        this.show = true
        return
      } else {
        let sort = this.search.sort
        this.search = this._dep(this._search)
        if (v == 2) {
          //价格
          if (sort == 1) { this.search.sort = '2' }
          else { this.search.sort = '1' }
        } else {
          this.search.sort = v

        }
      }

      this.clearScrollResult()
      this.m_loadList()
    },

    clickGoods(item) {
      this.$router.push(`/goodsDetail?id=${item.id}`)

    },

    handelResetbtn() {
      this.pirce_min = ''
      this.price_max = ''
    },

    handelSureBtn() {
      let pirce_min = this.isNaN0(this.pirce_min)
      let price_max = this.isNaN0(this.price_max)

      if (pirce_min < 0 || price_max < 0) {
        this.m_toast('金额必须大于0')
        return
      }
      if (price_max < pirce_min) {
        // this.m_toast('最高价不能低于最低价')
        pirce_min = 0

      }

      this.search.pirce_min = pirce_min || ''
      this.search.price_max = price_max || ''
      this.clearScrollResult()
      this.m_loadList()
      this.show = false
    },







  },
  filters: {
    arrow(v) {
      if (v == 2) {
        return 'arrow-up'
      } else {
        return 'arrow-down'
      }
    }
  }
}

</script>
<style lang='scss' scoped>
.topbar {
  position: fixed;
  width: 100%;
  height: 0.8rem;
  background: #fff;
  font-size: 0.28rem;
  border: 1px solid #eee;
  z-index: 999;
  .active {
    color: #4C80C1;
  }
}

.goodsList {
  // padding-top: 0.8rem;
  box-sizing: border-box;
  height: 100%;
  .goodsBox {
    padding: 0.2rem;
    font-size: 0.28rem;
    background: #fff;
    border-bottom: 1px solid #eee;

    .goodsBox_con {
      padding-left: 0.2rem;
      box-sizing: border-box;
    }

    .f1 {
      font-weight: bold;
      font-size: 0.32rem;
    }
  }
  .c-m-box {
    margin-top: 0.2rem;
    margin-bottom: 0.2rem;
    color: #999;
  }

  .redf {
    color: red;
    font-size: 0.36rem;
  }

  .quan {
    padding: 0.05rem;
    background: #f17c57;
    color: #fff;
    margin-right: 0.1rem;
  }
  .c-m-1box {
    color: #f17c57;
  }
  .bb-text {
    font-size: 0.26rem;
    color: #333;
  }
}

.searchBox {
  height: 100%;
  width: 80%;
  .searchBox_c {
    box-sizing: border-box;
    font-size: 0.3rem;
    color: #444;
  }
  .searchBox_f {
    position: absolute;
    bottom: 0;
    width: 100%;
    height: 1rem;
    border-top: 1px solid #eee;
  }

  .resetBtn {
    height: 1rem;
    background: #fff;
    line-height: 1rem;
    color: #333;
    text-align: center;
  }
  .sureBtn {
    height: 1rem;
    background: #4C80C1;
    line-height: 1rem;
    color: #fff;
    text-align: center;
  }
}

.s_item {
  padding: 0.26rem;
  box-sizing: border-box;
}

.n_input {
  width: 2.4rem;
  height: 0.7rem;
  border: 1px solid #eee;
  border-radius: 5px;
  text-align: center;
}

.e2 {
  overflow: hidden;

  text-overflow: ellipsis;

  display: -webkit-box;

  -webkit-box-orient: vertical;

  -webkit-line-clamp: 3;
}
</style>